/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : tSet.h                                                   */
/*                                                                       */
/*       Date : August 22, 1998                                          */
/* Updated at : August 22, 1998                                          */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <new.h>

#include <deffunc.h>

#include "SortedSet.h"
#include "tSet.h"


/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
void SortedSet<T1,T2>::defineMe(unsigned _initialCapacity, float _gRate, float _sRate)
{
  //tSet<T1> *temp = new tSet<T1>(_initialCapacity,_gRate,_sRate);
  //mySet = *temp;
  index = 0;
  currentCapacity = capacity = 5;
  values = new T2[currentCapacity];
  mySet  = new T1[currentCapacity];
  gRate = _gRate;
  sRate = _sRate;

}// 

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
SortedSet<T1,T2>::SortedSet() { defineMe(1,2,0.5); }

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
SortedSet<T1,T2>::SortedSet(unsigned _initialCapacity)
{ defineMe(_initialCapacity,2,0.5); }

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
SortedSet<T1,T2>::SortedSet(unsigned _initialCapacity, float _gRate, float _sRate)
{ defineMe(_initialCapacity,_gRate,_sRate); } 

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
SortedSet<T1,T2>::SortedSet(const SortedSet<T1,T2>& RHS)
{
   dispose();
   copyFrom(RHS);

}// Copy Constructor

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2> SortedSet<T1,T2>::~SortedSet() { dispose(); } 

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
void SortedSet<T1,T2>::addElement(T1 ele, T2 fx)
{
  //cout << " addElement for ele: "  << ele << " fx: " << fx << endl;

  if(!isExistValue(ele))
  {
     //cout << " it does not exist! " << endl;

     int i, place=0;
     while( place<index && values[place]<fx) place++;

     //cout << " place " << place << endl;

     if(index>=currentCapacity) 
	adjustTo( currentCapacity + maximum(1,gRate*currentCapacity) );

     //cout << " fx: " << fx << endl;

     for(i=index-1;i>=place;i--) values[i+1]=values[i];
     for(i=index-1;i>=place;i--) mySet[i+1]=mySet[i];

     values[place] = fx;
     mySet[place]  = ele;

     index++;

     //cout << mySet << endl << " index: " << index << endl;

  }// end of if

}// end of addElement() 

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
int SortedSet<T1,T2>::isExistValue(T1 ele)
{
   int ret=0;

   for(unsigned i=0; !ret && i<index;i++) ret = ( ele == mySet[i] );

   return ret;

}// end of isExistValue() 

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
void SortedSet<T1,T2>::removeAt(int indx)
{
    if(indx>=0&&indx<index)
    {
       int i;	
       for(i=indx;i<index-1;i++) values[i]=values[i+1];
       for(i=indx;i<index-1;i++) mySet[i]=mySet[i+1];
       index--;

       // Adjust the Capacity of the Vector occationally
       if( ( currentCapacity-index)>(maximum(9,sRate*currentCapacity)) &&
	     index>capacity )
           adjustTo( currentCapacity - maximum(1,sRate*(currentCapacity-1)) );

    }// end of if

}// end of removeAt()

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
SortedSet<T1,T2>::getAt(int indx, T1& rturn) const
{
   int ret = 0;

   if(indx>=0&&indx<index) { rturn = mySet[indx] ; ret=1; }
	     
   return ret;

}// end of getAt()

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2> SortedSet<T1,T2>::getIndex() { return index; }

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
void SortedSet<T1,T2>::adjustTo( unsigned newSize )
{
   int nSize   = maximum(capacity,newSize); // do not go below capacity
   int ysize   = nSize/2;
   if( 2*ysize!=nSize) nSize++;

   T2 *temp  = new T2[nSize];
   T1 *temp1 = new T1[nSize];

   for(unsigned i=0;i<index && i<nSize;i++) 
   { temp[i] = values[i]; temp1[i] = mySet[i]; }

   if(currentCapacity) { delete[] values; delete[] mySet; }

   currentCapacity = nSize;
   values = temp ;
   mySet  = temp1 ;

}// end of adjustTo

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
void SortedSet<T1,T2>::dispose( )
{
  if(currentCapacity) 
  { 
    delete[] values;
    delete[] mySet;
  }
  index = 0;
  values = NULL;
  mySet  = NULL;
  currentCapacity = 0;

}// end of dispose()

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
void SortedSet<T1,T2>::copyFrom( const SortedSet<T1,T2>& RHS )
{
  capacity = RHS.capacity;
  currentCapacity = RHS.currentCapacity;
  index = RHS.index;
  gRate = RHS.gRate;
  sRate = RHS.sRate;

  values  = new T2[currentCapacity];
  mySet  =  new T1[currentCapacity];

  for(unsigned i=0;i<index&&i<currentCapacity;i++) 
  {
     values[i] = RHS.values[i];
     mySet[i]  = RHS.mySet[i];

  }// end of for

}// end of copyFrom()

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
void SortedSet<T1,T2>::printMe(ostream& out) const
{
   out << " printMe " << endl;
   out << " (" << index <<") { " ;
   for(unsigned i=0;i<index;i++) 
   {
       out << mySet[i] << " [" << values[i] << "] , ";
       if((i+1)%5==0) out << endl;
   }
   out << " } ";

}// end of printMe()

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
SortedSet<T1,T2>::operator==(const SortedSet<T1,T2>& RHS)
{
   int ret = ( index == RHS.index ) ;

   for(int i=0;ret&&i<index;i++) 
      ret = ( ( values[i] == RHS.values[i] ) && ( mySet[i] == RHS.mySet[i] ));

   return ret;

}// end of operator==()

/*************************************************************************/
/*************************************************************************/
template<class T1, class T2>
SortedSet<T1,T2> SortedSet<T1,T2>::operator=(const SortedSet<T1,T2>& RHS)
{
   dispose();
   copyFrom(RHS);
   return (*this);

}// end of operator=()


